Codeforces Round #294 (Div. 2) (D)前缀和+map

来源:互联网 发布:linux 不保存退出 编辑:程序博客网 时间:2024/06/05 00:37


D. A and B and Interesting Substrings
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

A and B are preparing themselves for programming contests.

After several years of doing sports programming and solving many problems that require calculating all sorts of abstract objects, A and B also developed rather peculiar tastes.

A likes lowercase letters of the Latin alphabet. He has assigned to each letter a number that shows how much he likes that letter (he has assigned negative numbers to the letters he dislikes).

B likes substrings. He especially likes the ones that start and end with the same letter (their length must exceed one).

Also, A and B have a string s. Now they are trying to find out how many substrings t of a string s are interesting to B (that is, t starts and ends with the same letter and its length is larger than one), and also the sum of values of all letters (assigned by A), except for the first and the last one is equal to zero.

Naturally, A and B have quickly found the number of substrings t that are interesting to them. Can you do it?

Input

The first line contains 26 integers xa, xb, ..., xz ( - 105 ≤ xi ≤ 105) — the value assigned to letters a, b, c, ..., z respectively.

The second line contains string s of length between 1 and 105 characters, consisting of Lating lowercase letters— the string for which you need to calculate the answer.

Output

Print the answer to the problem.

Sample test(s)
input
1 1 -1 1 1 1 1 1 1 1 1 1 1 1 1 7 1 1 1 8 1 1 1 1 1 1xabcab
output
2
input
1 1 -1 1 1 1 1 1 1 1 1 1 1 1 1 7 1 1 1 8 1 1 1 1 1 1aaa
output
2
Note

In the first sample test strings satisfying the condition above are abca and bcab.

In the second sample test strings satisfying the condition above are two occurences of aa.





题意:给你一个数组,每个数字是对应位置的字母权值,接下来有一个字符串,问在这个字符串是否能找到符合以下条件的子串

1.长度>=2

2.除去首位,末位,子串的权值和等于0

问可以在这个字符串里找到多少个 符合条件的子串


题解:开始是想到使用前缀和维护区间的和,使用尺取法 枚举区间,但是发现找不到条件促使“尺子移动”,这里我发现只有前缀和减少才会有机会使得子串的权值和为0。可是这样去枚举复杂度实在太高,查了题解规律是:若当前的字符相同,而且前缀和相同那么这个区间的权值和就是0,也就是满足题意的,因为和很大,这里可以使用map维护,这里的和其实是从相同的前缀和的N个点中选取2个,组合数学ans+=C(N,2);


#include <set>#include <map>#include <list> #include <cmath> #include <queue> #include <vector>#include <cstdio> #include <string> #include <cstring>#include <iomanip> #include <iostream> #include <sstream>#include <algorithm>#define LL long long using namespace std;#define N 100005int a[N];char s[N];LL prifix[N];map<LL,LL>q[200];int main(){#ifdef CDZSCfreopen("i.txt","r",stdin);#endifwhile(~scanf("%d",&a['a'])){memset(prifix,0,sizeof(prifix));prifix[0]=0;for(int i='b';i<='z';i++){q[i].clear();scanf("%d",&a[i]);}scanf("%s",s+1);for(int i=1;s[i];i++){prifix[i]+=prifix[i-1]+a[s[i]];}LL ans=0;for(int i=1;s[i];i++){ans+=q[s[i]][prifix[i-1]];q[s[i]][prifix[i]]++;}printf("%I64d\n",ans);}return 0;}









0 0
原创粉丝点击